=== debian/changelog ===
uftrace (0.8.2-1) unstable; urgency=low

  * New upstream release

 -- paul cannon <pik@debian.org>  Fri, 05 Jan 2018 13:23:39 -0600

uftrace (0.7.0-1) unstable; urgency=low

  * New upstream release (closes: #871596).
  * Add patch to fix calculation of message sizes under send_trace_metadata

 -- paul cannon <pik@debian.org>  Wed, 09 Aug 2017 12:08:47 -0500
