=== debian/control ===
--- 
+++ 
@@ -2,12 +2,13 @@
 Section: utils
 Priority: optional
 Maintainer: paul cannon <pik@debian.org>
-Build-Depends: debhelper (>= 9), libelf-dev, pandoc, python
-Standards-Version: 4.1.3
+Build-Depends: debhelper (>= 9), libelf-dev, pandoc, python, pkg-config,
+ libpython2.7-dev, libdw-dev, libncursesw5-dev
+Standards-Version: 4.2.1
 Homepage: https://github.com/namhyung/uftrace
 
 Package: uftrace
-Architecture: amd64 armhf
+Architecture: amd64 arm64 armhf
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: Traces and analyzes execution of programs written in C/C++
  The uftrace tool is intended for tracing and analyzing the execution of
